Open Infrastructure - Task #8687

Adjust django-hosting to run on Alpine Linux
12/05/2020 10:27 AM - Nico Schottelius

Status: Rejected Start date: 12/05/2020
Priority: Normal Due date:

Assignee: Nico Schottelius % Done: 0%
Category: Estimated time: 0.00 hour

Target version:
PM Check date:

Description

Currently testing with ula.ungleich.ch.

® nginx start missing

app user is locked by default (shadow entry with 1)

deprecated ssl configuration directive

uwsgi configuration seems not to be loaded -> needs permission change

History

#1 - 12/05/2020 10:27 AM - Nico Schottelius

* nginx is not automatically started -> certbot gives an error

INFO: [12802]: ula-v6.ungleich.ch: Processing __letsencrypt_cert/ula.ungleich.ch

ERROR: [12802]: ula-v6.ungleich.ch: ssh -o User=root -o ControlPath=/tmp/tmp5nw515hqg/s -o ControlMaster=auto -
o ControlPersist=2h ula-vé6.ungleich.ch /bin/sh -c ' export __object=/var/lib/cdist/object/__letsencrypt_cert/u
la.ungleich.ch/.cdist-9150xylo; export __object_id=ula.ungleich.ch;/bin/sh -e /var/lib/cdist/object/__letsenc
rypt_cert/ula.ungleich.ch/.cdist-9150xylo/code-remote': ['ssh', '-o', 'User=root', '-o', 'ControlPath=/tmp/tmp
5nw515hg/s', '-o', 'ControlMaster=auto', '-o', 'ControlPersist=2h', 'ula-v6.ungleich.ch', "/bin/sh -c ' export
__object=/var/lib/cdist/object/__letsencrypt_cert/ula.ungleich.ch/.cdist-9150xylo; export __object_id=ula.un
gleich.ch; /bin/sh -e /var/lib/cdist/object/__letsencrypt_cert/ula.ungleich.ch/.cdist-9150xylo/code-remote'"]

Error processing object '__ letsencrypt_cert/ula.ungleich.ch'

name: __letsencrypt_cert/ula.ungleich.ch

path: /tmp/tmprclzhcj0/a2937¢c96337251ad01lledfc78d9d26a3/data/object/__letsencrypt_cert/ula.ungleich.ch/.cdist—-
9150xylo

source: /tmp/tmprclzhcj0/a2937¢c96337251ad01ledfc78d9d26a3/data/conf/type/__ungleich_django_microservice/manife
st

type: /home/nico/vcs/cdist/cdist/conf/type/___letsencrypt_cert

code-remote:stderr
An unexpected error occurred:
Traceback (most recent call last):
File "/usr/lib/python3.8/site-packages/urllib3/contrib/pyopenssl.py", line 488, in wrap_socket
cnx.do_handshake ()
File "/usr/lib/python3.8/site-packages/OpenSSL/SSL.py", line 1934, in do_handshake
self._raise_ssl_error(self._ssl, result)
File "/usr/lib/python3.8/site-packages/OpenSSL/SSL.py", line 1663, in _raise_ssl_error
raise SysCallError (errno, errorcode.get (errno))
OpenSSL.SSL.SysCallError: (104, 'ECONNRESET')

During handling of the above exception, another exception occurred:

Traceback (most recent call last):

File "/usr/lib/python3.8/site-packages/urllib3/connectionpool.py", line 670, in urlopen
httplib_response = self._make_request (

File "/usr/lib/python3.8/site-packages/urllib3/connectionpool.py", line 381, in _make_request
self._validate_conn (conn)

File "/usr/lib/python3.8/site-packages/urllib3/connectionpool.py", line 976, in _validate_conn
conn.connect ()

File "/usr/lib/python3.8/site-packages/urllib3/connection.py", line 361, in connect
self.sock = ssl_wrap_socket (

File "/usr/lib/python3.8/site-packages/urllib3/util/ssl_.py", line 377, in ssl_wrap_socket
return context.wrap_socket (sock, server_hostname=server_hostname)
File "/usr/lib/python3.8/site-packages/urllib3/contrib/pyopenssl.py", line 494, in wrap_socket

raise ssl.SSLError ("bad handshake: %r" % e)
ssl.SSLError: ("bad handshake: SysCallError (104, 'ECONNRESET')",)

During handling of the above exception, another exception occurred:

Traceback (most recent call last):
File "/usr/lib/python3.8/site-packages/requests/adapters.py", line 439, in send
resp = conn.urlopen (
File "/usr/lib/python3.8/site-packages/urllib3/connectionpool.py", line 724, in urlopen
retries = retries.increment (
File "/usr/lib/python3.8/site-packages/urllib3/util/retry.py", line 439, in increment
raise MaxRetryError (_pool, url, error or ResponseError (cause))
urllib3.exceptions.MaxRetryError: HTTPSConnectionPool (host="'acme-v02.api.letsencrypt.org', port=443): Max retr
ies exceeded with url: /directory (Caused by SSLError (SSLError ("bad handshake: SysCallError (104, 'ECONNRESET')
"))

During handling of the above exception, another exception occurred:

requests.exceptions.SSLError: HTTPSConnectionPool (host='acme-v02.api.letsencrypt.org', port=443): Max retries
exceeded with url: /directory (Caused by SSLError (SSLError ("bad handshake: SysCallError (104, 'ECONNRESET')")))
Please see the logfiles in /var/log/letsencrypt for more details.

VERBOSE: [12802]: config: Total processing time for 1 host(s): 144.5763819217682

#2 - 12/05/2020 10:46 AM - Nico Schottelius
- Description updated

#3 - 12/05/2020 11:04 AM - Nico Schottelius

- Description updated

2020/12/05 11:03:50 [warn] 3251#3251: the "ssl" directive is deprecated, use the "listen ... ssl" directive in
stead in /etc/nginx/conf.d/https-ula.ungleich.ch:13

2020/12/05 11:03:50 [warn] 3254#3254: the "ssl" directive is deprecated, use the "listen ... ssl" directive in

stead in /etc/nginx/conf.d/https-ula.ungleich.ch:13

#4 - 12/05/2020 11:10 AM - Nico Schottelius
- Description updated

[11:06] ula-v6:/var/log/uwsgi# less uwsgi.log
[emperor-tyrant] invalid permissions for vassal app.ini

[11:08] ula-vé6:/var/log/uwsgi# cat /etc/uwsgi/conf.d/readme.emperor

drop your uwsgi config files inside this directory uwsgi will automatically
load them (Emperor mode) and start a vassal.

uwsgi will run the vassal using the UID/GID of the vassal configuration file.
see: http://uwsgi-docs.readthedocs.io/en/latest/Emperor.html

make sure your webserver belongs to the uwsgi group to access the socket.
[11:08] ula-vé6:/var/log/uwsgi# chown app:app /etc/uwsgi/

conf.d/ uwsgi.ini
[11:08] ula-v6:/var/log/uwsgi# chown app:app /etc/uwsgi/
conf.d/ uwsgi.ini

[11:08] ula-v6:/var/log/uwsgi# chown app:app /etc/uwsgi/conf.d/app.ini

#5 - 12/05/2020 11:11 AM - Nico Schottelius

- Description updated

Jin-Guk, can you checkout above problems, fix them in cdist, create a new test instance

#6 - 12/15/2020 11:09 AM - Jin-Guk Kwon

- set new instance (ipv6only, alpine3.12)

- when i ran cdist. there is no error message

INFO: [1589]: test-ula-v6.lab.ungleich.ch: Processing __package_apk/certbot
VERBOSE: [31477]: test-ula-vé6.lab.ungleich.ch: Running object __package/certbot
VERBOSE: [31477]: test-ula-v6.lab.ungleich.
INFO: [31477]: test-ula-vé6.lab.ungleich.ch:
VERBOSE: [31477]: test-ula-v6.lab.ungleich.

ich.ch

VERBOSE: [31477]: test-ula-v6.lab.ungleich.

test-ula.lab.ungleich.ch

VERBOSE: [31477]: test-ula-v6.lab.ungleich.

nx>
VERBOSE: [31477]: test-ula-v6.lab.ungleich

ch: Running object __letsencrypt_cert/test-ula.lab.ungleich.ch
Processing __letsencrypt_cert/test-ula.lab.ungleich.ch

ch: Preparing object __ungleich_dynamicweb_nginx/test-ula.lab.ungle
ch: Running manifest and explorers for __ungleich_dynamicweb_nginx/

ch: Running type explorers for <CdistType __ungleich_dynamicweb_ngi

.ch: Running type manifest /tmp/tmpdufukk_x/c4efb3c7713ccl9p9938cc55

b79bclee/data/conf/type/__ungleich_dynamicweb_nginx/manifest for object __ungleich_dynamicweb_nginx/test-ula.l

ab.ungleich.ch
VERBOSE: [31477]: test-ula-v6.lab.ungleich
leich.ch

VERBOSE: [31477]: test-ula-vé6.lab.ungleich.

s—-test-ula.lab.ungleich.ch

VERBOSE: [31477]: test-ula-v6.lab.ungleich.

VERBOSE: [31477]: test-ula-vé6.lab.ungleich
ich.ch

INFO: [31477]: test-ula-vé6.lab.ungleich.ch:
VERBOSE: [31477]: test-ula-v6.lab.ungleich.

h.ch

VERBOSE: [31477]: test-ula-v6.lab.ungleich.
INFO: [31477]: test-ula-vé6.lab.ungleich.ch:

VERBOSE: [31477]: config: Total processing
control%

#7 - 12/15/2020 11:19 AM - Jin-Guk Kwon

- nginx status

.ch: Preparing object __ _file/etc/nginx/conf.d/https-test-ula.lab.ung
ch: Running manifest and explorers for __file/etc/nginx/conf.d/http

ch: Running type explorers for <CdistType __ file>
.ch: Running object __file/etc/nginx/conf.d/https-test-ula.lab.ungle

Processing __file/etc/nginx/conf.d/https-test-ula.lab.ungleich.ch
ch: Running object __ungleich_dynamicweb_nginx/test-ula.lab.ungleic

ch: Running object __ungleich_django_microservice/
Finished successful run in 166.01 seconds
time for 1 host(s): 166.22307467460632

[11:12] test-ula-v6:/etc/nginx/conf.d# netstat -tnlp

Active Internet connections (only servers)

Proto Recv-Q Send-Q Local Address Foreign Address State PID/Program name
tcp 0 0 0.0.0.0:80 0.0.0.0:%* LISTEN 5170/nginx.conf
tcp 0 0 0.0.0.0:22 0.0.0.0:* LISTEN 4046/sshd [listener
tcp 0 0 127.0.0.1:5432 0.0.0.0:%* LISTEN 4743/postgres
tcp 0 0 :::80 g LISTEN 5170/nginx.conf
tcp 0 @ 83322 8 LISTEN 4046/sshd [listener
tcp 0 0 ::1:5432 888w LISTEN 4743/postgres
[11:13] test-ula-v6:/etc/nginx/conf.d# service nginx status

* status: started

[11:13] test-ula-v6:/etc/nginx/conf.d#

[11:13] test-ula-v6:/etc/nginx/conf.d# service nginx restart

* Stopping nginx

[ ok ]

nginx: [warn] the "ssl" directive is deprecated, use the "listen ... ssl" directive instead in /etc/nginx/conf
.d/https-test-ula.lab.ungleich.ch:13

* Starting nginx ...
nginx: [warn] the "ssl" directive is deprecated, use the "listen ... ssl" directive instead in /etc/nginx/conf
.d/https-test-ula.lab.ungleich.ch:13 [ ok ]

[11:14] test-ula-v6:/etc/nginx/conf.d# netstat -tnlp
Active Internet connections (only servers)
Proto Recv-Q Send-Q Local Address Foreign Address State PID/Program name
tcp 0 0 0.0.0.0:80 0.0.0.0:%* LISTEN 5443/nginx.conf
tcp 0 0 0.0.0.0:22 0.0.0.0:* LISTEN 4046/sshd [listener
tcp 0 0 127.0.0.1:5432 0.0.0.0:%* LISTEN 4743/postgres
tcp 0 0 0.0.0.0:443 0.0.0.0:%* LISTEN 5443/nginx.conf
tcp 0 0 :::80 HE LISTEN 5443/nginx.conf
tcp 0 0 :::22 B LISTEN 4046/sshd [listener
tcp 0 0 ::1:5432 HE LISTEN 4743 /postgres
tcp 0 0 :::443 H LISTEN 5443/nginx.conf

[11:14] test-ula-v6:/etc/nginx/conf.d#

#8 - 12/15/2020 11:20 AM - Jin-Guk Kwon

[11:19] test-ula-v6:/etc/nginx/conf.d# nginx -v

nginx version: nginx/1.18.0
[11:32] test-ula-v6:/etc/nginx/conf.d#

The ssl parameter of the listen directive should be used instead

http://nginx.org/en/docs/http/ngx_http_ssl_module.html

[11:16] test-ula-v6:/etc/nginx/conf.d# vi https-test-ula.lab.ungleich.ch

03/13/2024

3/4


http://nginx.org/en/docs/http/ngx_http_ssl_module.html

listen 443 ssl;
listen [::]:443 ssl;

[11:18] test-ula-v6:/etc/nginx/conf.d# service nginx restart
* Stopping nginx ...
[ ok ]
* Starting nginx ...
[ ok ]
[11:18] test-ula-v6:/etc/nginx/conf.d#

#9 - 01/02/2024 02:12 PM - Nico Schottelius

- Status changed from In Progress to Rejected
